import { BaseNetworkInterface, RequestAndOptions } from "apollo-client/transport/networkInterface";
import { MiddlewareInterface } from "apollo-client/transport/middleware";
import { AfterwareInterface } from "apollo-client/transport/afterware";
import { ExecutionResult } from "graphql";
import { Request as RequestMyApollo } from "apollo-client/transport/networkInterface";
export interface AwsApiGwClient {
    isAuthenticated(): Boolean;
    authenticationExpired(): void;
    graphqlPost(param: Object, body: Object, extra: Object): Promise<any>;
}
export declare class AwsApiGwNetworkInterface extends BaseNetworkInterface {
    _middlewares: MiddlewareInterface[];
    _afterwares: AfterwareInterface[];
    private awsApiGatewayClient;
    constructor(client: AwsApiGwClient);
    fetchFromAwsApiGw({request, options}: RequestAndOptions): Promise<Response>;
    query(request: RequestMyApollo): Promise<ExecutionResult>;
}
