"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var networkInterface_1 = require("apollo-client/transport/networkInterface");
var AwsApiGwNetworkInterface = (function (_super) {
    __extends(AwsApiGwNetworkInterface, _super);
    function AwsApiGwNetworkInterface(client) {
        var _this = _super.call(this, 'http://') || this;
        _this.awsApiGatewayClient = client;
        return _this;
    }
    AwsApiGwNetworkInterface.prototype.fetchFromAwsApiGw = function (_a) {
        var request = _a.request, options = _a.options;
        return this.awsApiGatewayClient.graphqlPost({}, networkInterface_1.printRequest(request), { request: request, options: options });
    };
    ;
    AwsApiGwNetworkInterface.prototype.query = function (request) {
        var _this = this;
        var options = __assign({}, this._opts);
        if (!this.awsApiGatewayClient.isAuthenticated()) {
            return new Promise(function (resolve, reject) {
                reject(new Error('AWS API GW client not ready/authenticated !'));
            });
        }
        else {
            return this.fetchFromAwsApiGw({ request: request, options: options })
                .then(function (response) {
                var httpResponse = response['data'];
                if (response.status === 401 || response.status === 403) {
                    _this.awsApiGatewayClient.authenticationExpired();
                }
                if (response.status >= 300) {
                    var httpError = new Error("Network request failed with status " + response.status + " - \"" + response.statusText + "\"");
                    httpError.response = httpResponse;
                    throw httpError;
                }
                return httpResponse;
            })
                .then(function (payload) {
                if (!payload.hasOwnProperty('data') && !payload.hasOwnProperty('errors')) {
                    throw new Error("Server response was missing for query '" + request.debugName + "'.");
                }
                else {
                    return payload;
                }
            });
        }
    };
    ;
    return AwsApiGwNetworkInterface;
}(networkInterface_1.BaseNetworkInterface));
exports.AwsApiGwNetworkInterface = AwsApiGwNetworkInterface;
//# sourceMappingURL=api-gw-connector.js.map